<?php
function rozetta_add_post($data) {
    $post = get_post($data['id']);
  
    if (empty( $post )) {
      return null;
    }

    $new_post = array(
        'post_title' => $post->post_title,
        'post_content' => $post->post_content,
        'post_author' => $post->post_author,
        'post_type' => $post->post_type,
        'post_status' => 'draft'
    );

    $post_id = wp_insert_post($new_post);
    $original_post_id = $data['id'];
    if (get_post_meta($data['id'], '_rozetta_original_post_id', true)) {
        $original_post_id = get_post_meta($data['id'], '_rozetta_original_post_id', true);
    }
    update_post_meta( $post_id, '_rozetta_locale', $data['lang'] );
    update_post_meta( $post_id, '_rozetta_original_post_id', $original_post_id );

    return get_post($post_id);
}
add_action('rest_api_init', function () {
    register_rest_route( 'rozetta-wp-api/v1', '/post/(?P<id>[a-zA-Z0-9-]+)/lang/(?P<lang>[a-zA-Z-]+)', array(
      'methods' => 'POST',
      'callback' => 'rozetta_add_post',
      'args' => array(),
      'permission_callback' => '__return_true',
    ));
});

function rozetta_return_actived_langs() {
    $rtn_array = array();
    foreach ( RozettaMultilingual::get_actived_langs() as $lang ) {
        array_push($rtn_array, array(
            'lang' => $lang,
            'langName' => rozetta_get_languages_array()[$lang]
        ));
    }
    return $rtn_array;
}
add_action('rest_api_init', function () {
    register_rest_route( 'rozetta-wp-api/v1', '/activedLangs', array(
      'methods' => 'GET',
      'callback' => 'rozetta_return_actived_langs',
      'args' => array(),
      'permission_callback' => '__return_true',
    ));
});


function rozetta_return_other_posts($data) {
    $post_id = $data['id'];

    $current_original_post_id =  get_post_meta($post_id, '_rozetta_original_post_id', true);

    $rtn_array = array();

    $contnetArray = get_posts(array('post_status' => array('publish', 'pending', 'draft', 'future', 'private'), 'post_type' => get_post($post_id)->post_type, 'nopaging' => true));
    if (get_post($post_id)->post_type == 'page') {
        $contnetArray = get_pages(array('post_status' => array('publish', 'pending', 'draft', 'future', 'private'), 'post_type' => get_post($post_id)->post_type, 'nopaging' => true));
    }
    wp_set_current_user(1);
    foreach ($contnetArray as $post) {
        $original_post_id = get_post_meta($post->ID)['_rozetta_original_post_id'][0];
        if (($post_id == $post->ID || $original_post_id != '') && $original_post_id == $current_original_post_id || $post_id == $original_post_id || $post->ID == $current_original_post_id) {
            if ($post_id != $post->ID) {
                array_push($rtn_array, array(
                    'lang' => get_post_meta($post->ID, '_rozetta_locale', true),
                    'langName' => __(rozetta_get_languages_array()[get_post_meta($post->ID, '_rozetta_locale', true)], 'rozetta-translator'),
                    'post_id_link' => htmlspecialchars_decode(get_edit_post_link($post->ID))
                ));
            }
        }
    }
    wp_set_current_user(0);
    return $rtn_array;
}
add_action('rest_api_init', function () {
    register_rest_route( 'rozetta-wp-api/v1', '/otherPost/(?P<id>[a-zA-Z0-9-]+)', array(
      'methods' => 'GET',
      'callback' => 'rozetta_return_other_posts',
      'args' => array(),
      'permission_callback' => '__return_true',
    ));
});
?>